$('document').ready(function() {
  // Copied verbatim from https://docs.djangoproject.com/en/1.9/ref/csrf/
  function getCookie(name) {
    var cookieValue = null;
    if (document.cookie && document.cookie != '') {
      var cookies = document.cookie.split(';');
      for (var i = 0; i < cookies.length; i++) {
        var cookie = jQuery.trim(cookies[i]);
        // Does this cookie string begin with the name we want?
        if (cookie.substring(0, name.length + 1) == (name + '=')) {
          cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
          break;
        }
      }
    }
    return cookieValue;
  }
  var csrftoken = getCookie('csrftoken');

  function csrfSafeMethod(method) {
    // these HTTP methods do not require CSRF protection
    return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
  }
  $.ajaxSetup({
    beforeSend: function(xhr, settings) {
      if (!csrfSafeMethod(settings.type) && !this.crossDomain) {
        xhr.setRequestHeader("X-CSRFToken", csrftoken);
      }
    }
  });
  // End of verbatim copies

  var searchSuggestions = new Bloodhound({
    datumTokenizer: Bloodhound.tokenizers.obj.whitespace('value'),
    queryTokenizer: Bloodhound.tokenizers.whitespace,
    remote: {
      url: '/api/v1/search/suggest.json?query=%QUERY&limit=5',
      wildcard: '%QUERY'
    }
  });
  $('#addMeAsAResponsible').click(function() {
    var objectid = $('#inventoryobjectid').val();
    var payload;
    $.getJSON('/api/v2/objects/'+objectid+'/', function(data){
      var persons = data['responsible'];
      persons.push($('#currentUserName').val());
      payload = {
        responsible: persons,
      }
      console.log(payload);
      $.ajax({
        type: "PATCH",
        url: '/api/v2/objects/'+objectid+'/',
        data: JSON.stringify(payload),
        dataType: 'json',
        contentType: 'application/json; charset=UTF-8',
        jsonp: false,
        success: function(data) {
          $(location).attr('href','/object/'+objectid+'.html');
        },
      });
    });
  });
  $('#labelsForm')
        .find('[name="labels"]')
            .change(function (e) {
              $(this).preventDefault;
              objectid = $('#objectid').val();
              var payload = {
                id: objectid,
                labels: $(this).tagsinput('items')
              };
              $.ajax({
                type: "PATCH",
                url: '/api/v2/objects/'+objectid+'/',
                data: JSON.stringify(payload),
                dataType: 'json',
                contentType: 'application/json; charset=UTF-8',
                jsonp: false,
              });
            })
            .end();
  $('#removeMeAsAResponsible').click(function() {
    var objectid = $('#inventoryobjectid').val();
    var payload;
    $.getJSON('/api/v2/objects/'+objectid+'/', function(data){
      var persons = data['responsible'];
      persons = $.grep(persons, function(n, id) {
        return (n != $('#currentUserName').val());
      });
      payload = {
        responsible: persons,}
      console.log(payload);
      $.ajax({
        type: "PATCH",
        url: '/api/v2/objects/'+objectid+'/',
        data: JSON.stringify(payload),
        dataType: 'json',
        contentType: 'application/json; charset=UTF-8',
        jsonp: false,
        success: function(data) {
          $(location).attr('href','/object/'+objectid+'.html');
        },
      });
    });
  });
  $('#searchqueryinput').typeahead(null, {
    name: 'searchSuggestions',
    source: searchSuggestions
  });
});
